-- this script is made out of 2 parts building the db
-- and testing it I would reccomend looking at the comments of the testing
-- section as it runs for an explanation of whats happpening

DROP SCHEMA IF EXISTS `SuperGeeks`;
CREATE SCHEMA `SuperGeeks`;
USE `SuperGeeks`;
DROP TABLE IF EXISTS `Parents`;
CREATE TABLE `Parents`(
parentID varchar(40) not null unique,
primary key (parentID),
fname varchar(35),
lname varchar(35),
email varchar(320) unique,
-- maximum size of an email address should be able to store absolutely all possible email addresses
-- unable to view payment info from any select functions it is also encrypted for custowamer safety
paymentinfo varchar(50),
subscribed bool,
phonenum int(10));
   DROP TABLE if exists `sessionGroup`;
    create table `sessionGroup`(
		groupID varchar(40) primary key unique,
        ageGroup int(3));
DROP TABLE IF EXISTS `Students`;
CREATE TABLE `Students`(
studentID varchar(40) not null unique,
studentCode int key auto_increment,
fname varchar(35),
lname varchar(35),
-- The UK Government Data Standards Catalogue reccomends 35 characters for each the first name and last name
bday date,
dayjoined date DEFAULT now(),
parentsID varchar(40),
groupID varchar(40),
FOREIGN KEY (parentsID) REFERENCES Parents(parentID));

-- parent ID is stored in student rather than the parents table so that one parent can have many children
-- and not one child can have many parents. A child may have multiple parents irl but they would share an
-- account

ALTER TABLE Students auto_increment = 30001;
DROP TABLE IF EXISTS `Volunteers`;
CREATE TABLE `Volunteers`(
	VolunteerID varchar(40) not null unique,
    VolunteerCode int auto_increment,
    primary key (volunteerCode,VolunteerID),
    fname varchar(35),
    lname varchar(35),
    hoursworked int(8) DEFAULT 0,
    DBSdue date,
    SGdue date,
    emergencycontact varchar(20),
    email varchar(320)
	);
alter table Volunteers auto_increment = 1001;
DROP TABLE IF EXISTS `Sessions`;
CREATE TABLE `Sessions`(
	sessionID varchar(40) not null unique,
    primary key (sessionID),
    leaderID varchar(40),
    location varchar(35),
    duration int(10),
		occuredOn date,
    FOREIGN KEY (leaderID) REFERENCES Volunteers(VolunteerID),
    maxAttendees int(10),
		ageGroup int(3),
    groupid varchar(40),
		reviewOfProgression varchar(400),
		reviewOfstaffSafety varchar(400),
		Nohelpers int(10));

DROP TABLE IF EXISTS `Badge`;
CREATE TABLE `Badge`(
	BadgeID varchar(40) not null unique,
    primary key(BadgeID),
    badgeName varchar(35),
    badgeDesc varchar(255),
		ageGroup int(2)
	);

		DROP TABLE IF EXISTS `WaitList`;
		CREATE TABLE `WaitList`(

			studentID varchar(40) unique,
			groupID varchar(40),
			dateJoined datetime default now(),
			dateRemoved date,
	 		ageGroup int(2),
			FOREIGN KEY (studentID) REFERENCES Students(studentID));


			DELIMITER ££
			CREATE TRIGGER verifyAge BEFORE INSERT
			-- MAKES SURE THE STUDENT IS BEING ADDED TO
			-- THE CORRECT AGE GROUP
				ON `WaitList`
				FOR EACH ROW BEGIN
					select datediff(CURDATE(),(select bday from students where studentID = NEW.StudentID limit 1)) into @age;
					if @age < 10 and NEW.ageGroup > 2 THEN
							signal sqlstate '45000';
					ELSEIF @age >= 10 AND @age < 13 and  NEW.ageGroup != 8 THEN
							signal sqlstate '45000';
							ELSEIF @age >= 13 AND @age < 17 and  NEW.ageGroup != 12 THEN
									signal sqlstate '45000';
							end if;

				END ££
				DELIMITER ;


DROP TABLE IF EXISTS `BadgeAwarded`;
CREATE TABLE `BadgeAwarded`(
  awardedID varchar(40) unique primary key,
	awardedto varchar(40),
	evidence varchar(1000),
    awardedby varchar(40),
    Badgeawarded varchar(40),
    dateAwarded date,
		isAwarded int(3),
		-- isAwarded is to review applications
		-- 2 means not reviewed
		-- 1 means successful applications
		-- 0 means fail
	FOREIGN KEY (awardedto) REFERENCES Students(studentID),
	FOREIGN KEY (awardedby) REFERENCES Volunteers(VolunteerID),
	FOREIGN KEY (Badgeawarded) REFERENCES Badge(BadgeID)
    );
-- DROP TABLE IF EXISTS `Badgereqs`;
CREATE TABLE `Badgereqs`(
    mustbecompleted varchar(40),
    tocomplete varchar(40),
    FOREIGN KEY (mustbecompleted) REFERENCES Badge(BadgeID),
    FOREIGN KEY (tocomplete) REFERENCES Badge(BadgeID)
);
DROP TABLE IF EXISTS `StudentAttendance`;
CREATE TABLE `StudentAttendance`(
	studentID varchar(40),
    sessionID varchar(40),
	FOREIGN KEY (studentID) REFERENCES Students(studentID),
	FOREIGN KEY (sessionID) REFERENCES Sessions(SessionID)
);


			DELIMITER ££
			CREATE TRIGGER verifyINgroup BEFORE INSERT
			-- MAKES SURE THE STUDENT IS BEING ADDED TO
			-- THE CORRECT AGE GROUP
				ON `StudentAttendance`
				FOR EACH ROW BEGIN
					IF NOT(
            (Select groupID FROM Students where studentID=NEW.studentID limit 1)
            =
            (select groupID from sessions where sessionID = NEW.SessionID)

          )THEN
          signal sqlstate '45000';
          END IF;



				END ££
				DELIMITER ;
DROP TABLE IF EXISTS `VolunteerAttendance`;
CREATE TABLE `VolunteerAttendance`(
	volunteerID varchar(40),
    sessionID varchar(40),
	FOREIGN KEY (VolunteerID) REFERENCES Volunteers(volunteerID),
	FOREIGN KEY (sessionID) REFERENCES Sessions(SessionID)
);
DELIMITER ££
CREATE TRIGGER verifyDBS BEFORE INSERT
-- MAKES SURE THE STUDENT IS BEING ADDED TO
-- THE CORRECT AGE GROUP
  ON `VolunteerAttendance`
  FOR EACH ROW BEGIN
    if datediff(CURDATE(),
        (SELECT DBSdue FROM Volunteers
              WHERE volunteerID=NEW.volunteerID limit 1)

      ) > 0
     THEN
        signal sqlstate '45000';

        end if;

  END ££
  DELIMITER ;



-- procedures 
drop procedure if exists addParent;
delimiter $$
CREATE PROCEDURE addParent(
    	IN fname varchar(35),
	IN lname varchar(35),
	IN email varchar(320),
	IN passwerd varchar(70),
	IN phonenum int(10))

BEGIN
    DECLARE EXIT HANDLER FOR 1062
    BEGIN
 	SELECT 'User already exists' as ERROR ;
    END;

--    if (locate("@",email) = 0
	-- 	Select "invalid email as Error";
-- ADDS A ROW TO THE PARENTS TABLE WHILE FORMATTING THE id CORRECTLY
        INSERT INTO Parents(parentID,fname,lname,email,phonenum) values
	(md5(concat(email,passwerd)),fname,lname,email,phonenum);
END$$addParent
DELIMITER ;
drop procedure if exists addVolunteer;
delimiter $$
CREATE PROCEDURE addVolunteer(
	IN fname varchar(35),
	IN lname varchar(35),
	IN email varchar(320),
	IN passwerd varchar(70),
	IN phonenum varchar(20))

BEGIN
    DECLARE EXIT HANDLER FOR 1062
    BEGIN
 	SELECT 'User already exists' as ERROR ;
    END;
		IF INSTR(email,"@") > 0 then

        INSERT INTO Volunteers(VolunteerID,fname,lname,email,emergencycontact) values
	(md5(concat(email,passwerd)),fname,lname,email,phonenum);

	end if;
END$$
DELIMITER ;

drop procedure if exists VoltoStuRatio;
delimiter $$
CREATE PROCEDURE VoltoStuRatio(
	IN ageGroup int(3),
	IN noOfVols int(10))
-- CONVERTS THE AGE GROUP INTO THE MAX NUMBER OF
-- STUDENTS ALLOWED PER 1 VOLUNTEER
BEGIN
				IF ageGroup=1
					THEN
						SELECT 5 * noOfVols;
				ELSEIF ageGroup=2
					then
							select 8 * noOfVols;
				ELSEIF ageGroup=3
					THEN
							select 12 * noOfVols;
						END IF;

END$$
DELIMITER ;


drop procedure if exists addBadgereq;
delimiter $$
CREATE PROCEDURE addBadgereq(
  -- ADDS A REQUIREMENT FOR A BADGE`
	IN youNeed varchar(40),
	IN  toGet varchar(40))
	-- I use this naming scheme as it just makes it easy to understand
	-- which badge is which in this relationship

BEGIN
    DECLARE EXIT HANDLER FOR 1452
    BEGIN
 	SELECT 'Badge not found' as ERROR ;
    END;

        INSERT INTO Badgereqs(mustbecompleted,tocomplete) values
	(youNeed,toGet) ;
END$$
DELIMITER ;

drop procedure if exists addBadge;
delimiter $$
CREATE PROCEDURE addBadge(
  -- CREATES BADGE
	IN badgeName varchar(40),
	IN badgeDesc varchar(255))

BEGIN
    DECLARE EXIT HANDLER FOR 1062
    BEGIN
 	SELECT ' Badge already exists' as ERROR ;
    END;

        INSERT INTO Badge(BadgeID,badgeName,badgeDesc) values
	(md5(badgeName),badgeName,badgeDesc);
END$$
DELIMITER ;

drop procedure if exists `applyToGroup`;
delimiter $$
CREATE PROCEDURE applyToGroup(
-- PUTS THE Student ON THE WaitList
	IN studentID varchar(40),
	IN groupID varchar(40),
ageGroup int(2))
BEGIN
    DECLARE EXIT HANDLER FOR 1062
    BEGIN
 	SELECT 'This student is already on a wait list' as ERROR ;
    END;

        INSERT INTO WaitList(StudentID,groupID,dateJoined,ageGroup) values
	(StudentID,groupID,now(),ageGroup);
END$$
DELIMITER ;

drop procedure if exists `addPriorty`;
delimiter $$
CREATE PROCEDURE addPriorty(
-- addsMorePrioity to a specific student
	IN studentvID varchar(40),
  IN PriotityEffect int(2))
BEGIN
    DECLARE EXIT HANDLER FOR 1062
    BEGIN
 	SELECT 'This student is already on a wait list' as ERROR ;
    END;
	
        update WaitList set dateJoined=date_sub(dateJoined, interval PriotityEffect month) where studentID=studentvID; 
END$$
DELIMITER ;


drop procedure if exists addStudent;
delimiter $$
CREATE PROCEDURE addStudent(
	IN fname varchar(35),
	IN lname varchar(35),
    IN bday date,
    IN parentsID varchar(40),
	IN passwerd varchar(70))

BEGIN
    DECLARE EXIT HANDLER FOR 1062
    BEGIN
 	SELECT 'User already exists' as ERROR ;
    END;

        INSERT INTO Students(StudentID,fname,lname,bday,parentsID) values
	(md5(concat(fname,lname,passwerd)),fname,lname,bday,parentsID);

END$$
DELIMITER ;

drop procedure if exists viewStudent;
delimiter $$
CREATE PROCEDURE viewStudent(
  -- EITHER SHOWS ALL THE INFO ON A SPECIFIC OR ALL STUDENTS
	IN studentvID varchar(40))
BEGIN
	If LENGTH(studentvID) = 0
	then
 	SELECT s0.StudentID , s0.studentCode, s0.fname ,s0.lname,s0.bday,(select email from parents where parentID = s0.parentsID) as `emergency email`,(select phonenum from parents where parentID = s0.parentsID) as `emergency phone contact` from students as s0 ;
	else
	 	SELECT s0.StudentID , s0.studentCode, s0.fname ,s0.lname,s0.bday,(select email from parents where parentID = s0.parentsID),(select phonenum from parents where parentID = s0.parentsID) from students as s0 where studentvID=s0.studentID;
end if;
END$$
DELIMITER ;


drop procedure if exists viewVolunteer;
delimiter $$
CREATE PROCEDURE viewVolunteer(
  -- SHOWS ALL THE INFO ON A SPECIFIC OR ALL Volunteers
	IN VolunteervID varchar(40))
BEGIN
	If LENGTH(volunteervID) = 0
	then
 	SELECT s0.VolunteerID , s0.volunteerCode, s0.fname ,s0.lname,s0.DBSdue,s0.SGdue,s0.emergencycontact,s0.email,(select sum(duration) from Sessions where sessionID in(select sessionID from VolunteerAttendance where volunteerID=s0.volunteerID)) as "time "from volunteers as s0;
	else
	 		SELECT s0.VolunteerID , s0.volunteerCode, s0.fname ,s0.lname,s0.DBSdue,s0.SGdue,s0.emergencycontact,s0.email,(select sum(duration) from Sessions where sessionID in(select sessionID from VolunteerAttendance where volunteerID=s0.volunteerID)) as "time" from volunteers as s0 where volunteerID=volunteervID;
end if;
END$$
DELIMITER ;

drop procedure if exists Studentattends;
delimiter $$
CREATE PROCEDURE Studentattends(
  -- REPRESENTS A STUDENT ATTENDING A SPECIFIC SESSION
    IN studentID varchar(40),
		IN sessionID varchar(40))

BEGIN

        INSERT INTO StudentAttendance(StudentID,sessionID) values
	(studentID,sessionID);

END$$
DELIMITER ;

drop procedure if exists volunteerattends;
delimiter $$
CREATE PROCEDURE volunteerattends(
  -- RESPRESENTS A VOLUNTEER VOLUNTEERING
    IN volunteerID varchar(40),
		IN sessionID varchar(40))

BEGIN

        INSERT INTO volunteerAttendance(volunteerID,sessionID) values
	(volunteerID,sessionID);

END$$
DELIMITER ;

drop procedure if exists addSession;
delimiter $$
CREATE PROCEDURE addSession(
  -- CREATES A NEW ROW ON THE SESSION TABLE
  -- WHILST CORRECTLY FORMATTING THE ITEMS
	IN location varchar(35),
	IN duration int(10),
	IN learderID varchar(40),
    IN OccuredOn date,
		IN ageGroup int(3),
    IN groupID varchar(40))

BEGIN
		DECLARE EXIT HANDLER FOR 1062
    BEGIN
 	SELECT 'User already exists' as ERROR ;
    END;
        INSERT INTO Sessions(SessionID,location,duration,OccuredOn,groupID,leaderID,ageGroup) values
	(md5(concat(occuredOn,groupID)),location,duration, OccuredOn,groupID,learderID,ageGroup);
	call volunteerattends(learderID,md5(concat(occuredOn,groupID)));
END$$
DELIMITER ;

drop procedure if exists ReviewSession;
delimiter $$
CREATE PROCEDURE ReviewSession(
  -- UPDATES THE SESSION TABLE ADDING A review OF THE SESSION
	IN SessionID varchar(40),
	IN reviewOfProgression varchar(400),
	IN reviewOfstaffSafety varchar(400))

BEGIN
        UPDATE Sessions set reviewOfstaffSafety=reviewOfstaffSafety,reviewOfProgression=reviewOfProgression where SessionID=SessionID;
END$$
DELIMITER ;

drop procedure if exists `addToGroup`;
delimiter $$
CREATE PROCEDURE addToGroup(
	IN grapeID varchar(40))
-- adds students off the waitlist to fill the group
BEGIN
DECLARE toad INT DEFAULT 0;
DECLARE x INT Default 0;
DECLARE EXIT HANDLER FOR 1644 RESIGNAL;
BEGIN
SELECT "CANNOT APPLY FOR THAT GROUP" as ERROR ;
END;
select * from WaitList;
-- DO sleep(5);
select count(distinct volunteerID) *(SELECT ageGroup from sessiongroup where groupID=grapeID) into @maxstu from volunteerattendance as v0
				where grapeID in (select groupID from Sessions as s0
									where 	date_add(s0.OccuredOn, interval 31 day) > CURDATE() = 1) ;

			select count(distinct studentID) into @currentStu
				from StudentAttendance as stu0 where grapeID in
							(select groupID from  students as ts0 where stu0.studentID=ts0.studentID);
            set toad = @maxstu - @currentStu;
						-- toad reprisents how many students the program should add off the WaitList
						-- the next loop adds a student to the group from the waitlist equal
						-- to the amount of spaces available
            if toad is not null and toad >0 then
			adding_loop : LOOP
         SET x=x+1;
		 	select studentID
			 	from waitlist
				 	where (dateRemoved is null)
		 				 order by dateJoined asc limit 1 into @theChosenOnes;
 			UPDATE WaitList as wl0,students as stu2
		SET stu2.groupID=grapeID,wl0.dateRemoved=CURDATE() where wl0.studentID = @theChosenOnes and stu2.StudentID=@thechosenOnes;
    -- test

         IF x=toad THEN
            LEAVE adding_loop;
         END IF;
   END LOOP adding_loop;
   else
   select @maxstu, @currentStu;
   do sleep(2);
   end if;
	 select * from WaitList;
	 -- you should see that a number of students application should be successful
	 -- (if theres space) by dateremoved being null is they still are waiting or
	 -- todays date if they got added
END$$
DELIMITER ;


drop procedure if exists updateDBS;
delimiter $$
CREATE PROCEDURE updateDBS(
  -- updates the dbs check
	IN VolunteerID varchar(40),
	IN DateOfDBSApproval date)

BEGIN
        UPDATE volunteers set DBSdue =date_add(DateOfDBSApproval, interval 3 year)  where VolunteerID=volunteerID;
END$$
DELIMITER ;

drop procedure if exists viewBadges;
-- shows all the badges and their status of a specific student
delimiter $$
CREATE PROCEDURE viewBadges(
	-- This function shows
	IN StudentvID varchar(40))
BEGIN

 	SELECT if(ba.isAwarded=2,'Pending',(if (isAwarded = 1,'Complete','unsuccessful'))) as status,
				(select badgeName from badge where BadgeID=ba.badgeawarded limit 1) as 'name',
				(select badgeDesc from badge where BadgeID=ba.badgeawarded limit 1) as 'name',
				 ba.dateAwarded,
				concat((select fname from volunteers where volunteerID=ba.awardedby limit 1), ' ',(select lname from volunteers where volunteerID=ba.awardedby limit 1) ) as 'Awarded by',
				ba.evidence
				-- group by status
				from badgeawarded as ba where awardedto=studentvID group by status;

END$$
DELIMITER ;

drop procedure if exists volunteerviewBadges;
delimiter $$
CREATE PROCEDURE volunteerviewBadges()

	-- This function shows all badge applications for a volunteer
  -- so they can approve or deny them
BEGIN

 	SELECT awardedID,(select fname from students where studentID=b0.awardedto) as `applicant`,
    (select badgeName from badge where BadgeID=b0.BadgeAwarded) as `name`,
    (select badgeDesc from badge where BadgeID=b0.BadgeAwarded) as `requirements`,
    b0.evidence from BadgeAwarded as b0 where isAwarded = 2;


END$$
DELIMITER ;
-- under article 17 of the UK gdpr individuals
-- have the right to have personal data erased
-- next 3 functions handle deleting said data

drop procedure if exists EraseParent;
delimiter $$
CREATE PROCEDURE EraseParent(
	IN email varchar(320),
	IN passw varchar(70))
-- removes children as well
-- we need emergency contact details in case of emergency
-- we are not a financial institution so we don't have a legal requirement

BEGIN
        Delete from parents  where ParentsID=md5(concat(email,passw));
	-- 			Delete from badgeawarded where awardedto in (select studentID from students where parentsID=md5(concat(email,passw)));
		-- -		Delete from StudentAttendance as sa where sa.studentID in (select studentID from students where parentID=md5(concat(email,passw)));
			-- 	Delete from Students where parentsID=md5(concat(email,passw));
END$$
DELIMITER ;


drop procedure if exists updateSG;
delimiter $$
CREATE PROCEDURE updateSG(
  -- update the supergeeeks check date
	IN VolunteerID varchar(40),
	IN DateOfSGApproval date)

BEGIN
        UPDATE volunteers set SGdue =date_add(DateOfSGApproval, interval 5 year)  where VolunteerID=volunteerID;
END$$
DELIMITER ;

drop procedure if exists ViewCheckExpiries;
delimiter $$
CREATE PROCEDURE ViewCheckExpiries()
-- creates a report on all volunteers who have a check THAT
-- expires in the next 6 months
BEGIN
        SELECT volunteerID,fname,lname,DBSdue,SGdue,
				if(date_sub(DBSdue, interval 6 month) > CURDATE()=1,
				 		"ALL GOOD",
						if(CURDATE()>DBSdue=1
							,concat("already Due ",fname," does not have a valid dbs check"),
							concat("needs redoing in the before",DBSdue))) as "dbs refiew" ,
				if(date_sub(SGdue, interval 6 month) > CURDATE()=1 ,
				"ALL GOOD",
				if(CURDATE()>SGdue=1
					,concat("already Due ",fname," does not have a valid SG check"),  concat("needs redoing in the before",SGdue))) as "SuperGeeks training reviewz"
					from volunteers where date_sub(DBSdue, interval 6 month) < CURDATE()=1 or  date_sub(SGdue, interval 6 month) < CURDATE()=1;

END$$
DELIMITER ;


drop procedure if exists StudentBadgeApply;
delimiter $$
CREATE PROCEDURE StudentBadgeApply(
  -- submit an application for a specific badge
    IN studentID varchar(40),
		IN BadgeID varchar(40),
		IN badgeEvidence varchar(1000))

BEGIN

        INSERT INTO BadgeAwarded (awardedID,awardedto,BadgeAwarded,evidence,isAwarded) values((md5(concat(studentID,BadgeID))), studentID,BadgeID,badgeEvidence,2);

END$$
DELIMITER ;

drop procedure if exists badgeApprove;
delimiter $$
CREATE PROCEDURE badgeApprove(
  -- approves or denies a specific badge from a specific volunteer
    IN awardedID varchar(40),
		IN volunteerID varchar(40),
		IN result int(2))

BEGIN

        update BadgeAwarded as ba set ba.awardedby=volunteerID,dateAwarded=curdate(),isAwarded=result where awardedID=ba.awardedid;

END$$
DELIMITER ;

-- THIS IS THE TESTING SECTION
SELECT * FROM parents;
do sleep(2);
call addParent("jeff","Jones","email@realemail.com","veryStrongPassw0rd",02358254);
call addParent("tim","buckley","loss@realemail.com","veryStrongPassw0rd",118254);
select * from parents;
do sleep(2);
-- this is how we add parents to the db notice how it automatically hashes
-- to create an ID based on the information
call addBadge("real badge","respond with placeholder evidence in <>");
call addBadge("test badge","do not respond with hello world");
select * from badge;
select * from students;
do sleep(3);
insert into students (studentID,fname,lname,bday,dayjoined,parentsID,groupID)values ((md5(concat('bobby','jones','EXTRaSTRONGPASSWORD'))),"bobby","jones",'2012-2-11',curdate(),'8e301d6e513165a9c0b6b9a2b10c8305','41');

insert into students (studentID,fname,lname,bday,dayjoined,parentsID,groupID) values(md5(concat('timothy','jones','EXTREMELYSTRONGPASSWORD')),"timothy","jones",'2002-2-11',curdate(),'8e301d6e513165a9c0b6b9a2b10c8305','41');
call addStudent("samantha","jones",'2019-2-11','8e301d6e513165a9c0b6b9a2b10c8305','superSTRONGPASSWORD');
call addStudent("tom","jones",'2012-2-11','8e301d6e513165a9c0b6b9a2b10c8305','superSTRONGPASSWORD');
CALL addstudent('ethan','buckley','2013-03-02','4a85f9d4254038c83c3fc4f9b02b9619','weakpassword');
CALL addstudent('tibalt','buckley','2014-03-02','4a85f9d4254038c83c3fc4f9b02b9619','password');
call viewstudent('');

insert into sessiongroup values('41',5);


call viewstudent('');
do sleep(5);
-- this adds some dummy data in for the db to use
-- some students have been inserted straight into the db without a SP
-- so it seems they have been part of this organisation for a while
-- this will be relevent when I add the students to a group and need students already
-- part of a group

call applytogroup('4208a177bd0e3e81b682640e2c8078dd','41',5);
call addVolunteer("timothy","jones",'bob@bbc.co.uk','8e301d6e513165a9c0b6b9a2b10c8305',"0777008913");
call applytogroup('b6e14bcdd6a79c8f8cd9fcef3be5f00b', '41',5);
do sleep(1);
call applytogroup('7bd99d2efd6611161736f780a042f978','41',5);
do sleep(1);
-- 2 people were already in the group and 4 students have applied
-- tom jones was added last so he would be the one who will have to miss out
-- however Tom has been given priority so tibalt with id 7bd will miss out
call applytogroup('031f0ba110c9683bf4cf5d2836b32a95',41,5);
call addPriorty('031f0ba110c9683bf4cf5d2836b32a95',2);
call updateSG('419fd9859978a9bf79df4ff16c99c5f9',"2010-04-09");
call updateDBS('419fd9859978a9bf79df4ff16c99c5f9',"2021-09-09");
call viewCheckExpiries();
-- hmmm it appears volunteer tim doesn't have a valid sg check
--
call updateSG('419fd9859978a9bf79df4ff16c99c5f9',"2023-04-04");
-- now its valid

do sleep(2);
call addSession("computer lab",4,'419fd9859978a9bf79df4ff16c99c5f9','2023-02-03',5,'41');
call ReviewSession(md5('2023-02-03'),"it was ok","idk");

-- this is creating sessions and adding students and volunteers to the session
call addSession("computer lab",3,'419fd9859978a9bf79df4ff16c99c5f9','2023-01-03',5,'41');
call ReviewSession(md5('2023-01-03'),"it was ok","idk");
call addSession("computer lab",3,'419fd9859978a9bf79df4ff16c99c5f9','2022-11-03',5,'41');
call addSession("computer lab",13,'419fd9859978a9bf79df4ff16c99c5f9','2023-04-16',5,'41');
CALL STUDENTATTENDS('0ad073b3372ad0c243e6d465a2318568','94b21f931d888fefd4da7a07c01dff4a');
call studentattends('313b6d9a06c3a0618f72ec75c082b6a4','94b21f931d888fefd4da7a07c01dff4a');

call viewVolunteer('');
-- time volunteer has spent has been calculated from
do sleep(3);
select * from students;
do sleep(3);
call viewCheckExpiries();
call addToGroup('41');
do sleep(3);
-- you can see that tom jones is the only one not added as he joined the list last
select * from waitlist;

select * from students;
call StudentBadgeApply( '0ad073b3372ad0c243e6d465a2318568','fb635b87d668b2bbcc6a0b0a2f6adc32','<placeholder evidence that is what is needed>(correct)');
call StudentBadgeApply( '0ad073b3372ad0c243e6d465a2318568','fc1c7ce79f0265dd918c07588166cd03','hello world (incorrect)');
-- bobby jones with hash id of 0ad is applying for a badge
-- with the correct evidence to sign them off
call viewbadges('0ad073b3372ad0c243e6d465a2318568');
-- hmm it seems its pending
do sleep(3);
call volunteerviewbadges();
do sleep(3);
call badgeapprove('1ab31562f157f8489ae45bb767cbad43','419fd9859978a9bf79df4ff16c99c5f9',1);
call badgeapprove( 'a360ea99016380d8ee67bdb4d9048004','419fd9859978a9bf79df4ff16c99c5f9',0);

-- the volunteer timothy jones is validating the student booby's application it is correct so he is approving ity
-- the second application is incorrect so it is being rejected

call viewbadges('0ad073b3372ad0c243e6d465a2318568');
-- as you can see the correct badge has been approved and incorrect one has been rejected
do sleep(3);
-- it is correctly approved
